package com.outr.webcommunicator.netty

import handler.RequestHandler

/**
 * @author Matt Hicks <matt@outr.com>
 */
sealed class RequestResult

object RequestResult {
  /**
   * Bypasses handling with this resource. An explicit statement for this request to not be handled by this resource.
   */
  val Bypass = new RequestResult

  /**
   * Handles the request with the supplied handler.
   */
  case class Handle(handler: RequestHandler) extends RequestResult

  /**
   * No action requested by this result. Continue processing normally.
   */
  val Continue = new RequestResult
}
