package com.outr.webcommunicator.netty

import handler.RequestHandler
import org.jboss.netty.channel.{MessageEvent, ChannelHandlerContext}
import org.jboss.netty.handler.codec.http.HttpRequest

/**
 * @author Matt Hicks <matt@outr.com>
 */
class URIWebResource(val regex: String, val f: () => RequestHandler) extends WebResource {
  def request(webapp: NettyWebapp, context: ChannelHandlerContext, event: MessageEvent) = event.getMessage match {
    case request: HttpRequest if (request.path.matches(regex)) => Some(f())
    case _ => None
  }
}

object URIWebResource {
  def apply(regex: String)(f: => RequestHandler) = new URIWebResource(regex, () => f)
}
